;;; figs.scm --- 
   
;;;;   Copyright (C) 1997 GYVE Development Team
;;;;
;;;;   Author: Masatake YAMATO (masata-y@is.aist-nara.ac.jp)
;;;;   Created: Wed Oct 29 01:13:55 1997
;;;;   Time-stamp: <98/05/24 11:07:45 masata-y>
;;;;   
;;;;   This file is part of the GYVE vector based drawing editor. 
;;;;
;;;;   This program conforms GNU GENERAL PUBLIC LICENSE Version 2.

;;;; <Japanese> 
;; MEMO
;; * $BJV$jCM$NJ}$,(BBOOL$B$N%a%=%C%I$r8F$s$@>l9g(Bif$B$r;H$&A0$K(Bobjc-bool$B$r;H$&$3$H(B. 
;; * isKindOf:, isKindOfClass$B$H$$$&$h$&$J(BNSObject$B$+(B, Object$B$+$GF1$80UL#$N0c$&L>A0$N(B
;;   $B%a%=%C%I$,$"$k$3$H$KCm0U(B
;; * Objective-C$B$N(Bnil$B$K%a%C%;!<%8$rAw?.$9$k$H(Bnil$B$,5"$C$F$k$3$H$KCm0U(B
;;;;</Japanese>

(define-module (gyve figs) :use-module (languages guileobjc))

;;;;
; Constants
;;
(define-public gyve:figs:PI (* 2 ($acos 0)))

;;;;
; Thrown symbols
;;

;; * Public Thrown symbol gyve:figs:moveto-should-be-top
;; <Japanese>
;; gyve:figs:create-path$B$N0z?t$H$7$FM?$($?%j%9%H$NBh0lMWAG$,(Bmoveto$B%;%0%a%s%H(B
;; $B$G$J$$$H$-Ht$s$G$-$^$9(B. 
;; </Japanese>
(define-public gyve:figs:moveto-should-be-top 'gyve:figs:moveto-should-be-top)

;; * Public Thrown symbol gyve:figs:wrong-symbol-in-path-spec
;; <Japanese>
;; gyve:figs:create-path$B$N0z?t$H$7$FM?$($?%j%9%H$NMWAG$H$7$F(Bmoveto, lineto, curveto$B0J30(B
;; $B$NM?$($?>l9g$KHt$s$G$-$^$9(B. TODO: moveto$B$rM?$($?>l9g$bHt$P$9$3$H(B. 
;; </Japanese>
(define-public gyve:figs:wrong-symbol-in-path-spec 
  'gyve:figs:wrong-symbol-in-path-spec)

;; * Public Thrown symbol gyve:figs:un-printable-object
;; <Japanese>
;; gyve:figs:print$B$K0z?t$K%W%j%s%HITG=$J(Bscheme$B%*%V%8%'%/%H$rM?$($?>l9g$K(B
;; $BHt$s$G$-$^$9(B. $B$3$3$G8@$&%W%j%s%HITG=$H$O(B, PostScript$B%3!<%I$KJQ49$G$-$J$$(B
;; $B$H$$$&0UL#$G$9!#(B
;;</Japanese>
(define-public gyve:figs:un-printable-object 'gyve:figs:un-printable-object)

;; * Public Thrown symbol gyve:figs:out-of-range-zero-one
;;  <Japanese>
;; $B?'$d%0%i%G!<%7%g%s$N;XDj$K$*$$$F(B0-1$B$NHO0O$r1[$($kCM$rM?$($?>l9g$K(B
;; $BHt$s$G$-$^$9(B. 
;; </Japanese>
(define-public gyve:figs:out-of-range-zero-one 'gyve:figs:out-of-range-zero-one)

;; * Public Thrown symbol gyve:figs:wrong-painting
;;  <Japanese>
;; $B%+%i!<(B, $B%0%i%G!<%7%g%s$d%Q%?!<%s$r(Bpainting$B$r;XDj$9$k4X?t$K$*$$$F(B, 
;; $BITE,@Z$J$b$N$r0z?t$K;XDj$7$?>l9g$KHt$s$G$-$^$9(B. 
;; </Japanese>
(define-public gyve:figs:wrong-painting 'gyve:figs:wrong-painting)

;;;;
; Utilities
;;
;;
(define-public (gyve:figs:degree->radian degree)
  (* (/ degree 180) gyve:figs:PI))

;; Range checker
(define-public (gyve:figs:range-check min max target)
  (and (<= min target) (<= target max)))
(define-public (gyve:figs:range-check-zero-one target)
  (gyve:figs:range-check 0 1 target))
(define-public (gyve:figs:range-check-zero-one-and-throw target)
  (if (gyve:figs:range-check 0 1 target)
      target
      (throw gyve:figs:out-of-range-zero-one)))

;; Random number generator
(define-public gyve:figs:randomobj (objc-new GyveRandom init))
(define-public (gyve:figs:random-int beg end)
  ([] gyve:figs:randomobj randomIntBetween: beg and: end))

;; Mon Jan  5 06:51:05 1998
;; <Japanese>libobjects, gstep-base$B$N(B
;; Random$B%/%i%9$N(B-randomFloatBetween:and:$B$K$O%P%0$,$"$j$^$9(B. 
;; $B$=$l$r2sHr$9$k$?$a$K(B (+ beg ...)$B$7$F$$$^$9(B. 
;; $B%P%0$O(Bgstep ML$B$KJs9p$7$^$7$?(B. </Japanese>
;;(define-public (gyve:figs:random-float beg end)
;;  (+ beg ;; bug of libobjects and gstep-base
;;   ([] gyve:figs:randomobj randomFloatBetween: beg and: end)
;;     ))				
;; Thu Jun 25 04:43:41 1998
;; GyveRandom class$B$rMxMQ$9$k$h$&$KJQ99$7$?$N$G(B, + beg$B$9$kI,MW(B
;; $B$,$J$/$J$C$?(B. 
(define-public (gyve:figs:random-float beg end)
   ([] gyve:figs:randomobj randomFloatBetween: beg and: end)
   )
(define-public (gyve:figs:random-color-element)
  ([] gyve:figs:randomobj randomIntBetween: 0 and: 1))
(define-public (gyve:figs:random-color)
  (gyve:figs:create-rgb-color 
   ([] gyve:figs:randomobj randomFloatBetween: 0 and: 1)
   ([] gyve:figs:randomobj randomFloatBetween: 0 and: 1)
   ([] gyve:figs:randomobj randomFloatBetween: 0 and: 1)))

;; Accessing to the point object
(define-public (gyve:figs:x point)
  (list-ref point 0))
(define-public (gyve:figs:y point)
  (list-ref point 1))

;; Shared GOPI
(define gyve:figs:shared-gopi (objc-new GOPIPoint init))

;;;;
; Segment
;;
;; <Japanese>$B$?$V$s%U%!%$%k%W%i%$%Y!<%H$JJQ?t$@$+$i(Bgyve:figs$B$J$s$F$$$&@\F,<-(B
;; $B$O$$$i$J$$$H;W$&$1$I(B...</Japanese>
(define gyve:figs:ps-moveto (objc-class PSMovetoSegment))	
(define gyve:figs:ps-lineto (objc-class PSLinetoSegment))	
(define gyve:figs:ps-curveto (objc-class PSCurvetoSegment))

(define (gyve:figs:symbol->segment-class sym)
  (cond
   ((eq? 'moveto sym) gyve:figs:ps-moveto)
   ((eq? 'lineto sym) gyve:figs:ps-lineto)
   ((eq? 'curveto sym) gyve:figs:ps-curveto)
   (else 
    (throw gyve:figs:wrong-symbol-in-path-spec))))

(define (gyve:figs:segment->symbol seg)
  (gyve:figs:segment-class->symbol([] seg class)))

(define (gyve:figs:segment-class->symbol class)
  (cond 
   ((equal? class gyve:figs:ps-lineto)
    'lineto)
   ((equal? class gyve:figs:ps-moveto)
    'moveto)
   ((equal? class gyve:figs:ps-curveto)
	    'curveto)))

;; <Japanese>$B%U%#%k%?!<%W%m%0%i%^$K$H$C$FJXMx$@$H;W$&$N$G%Q%V%j%C%/$K$7$F(B
;; $B$*$-$^$9(B. </Japanese>
;; * Public Thrown symbol gyve:figs:create-segment 
;; <Japanese>
;; - (list 'moveto x y)
;; - (list 'lineto x y)
;; - (list 'curveto x0 y0 x1 y1 x2 y2)
;; $B$N$I$l$r$+%;%0%a%s%H$NDj5A$H$7$FM?$($k$H(B, $B$=$NDj5A$+$i(BPSSegment$B%*%V%8%'%/%H(B
;; $B$r:n$k(B. 
;; XXX: $B>\$7$$@bL@$,I,MW(B
;; </Japanese>
(define-public (gyve:figs:create-segment segment)
  (let* ((segclass (gyve:figs:symbol->segment-class (car segment)))
	 (coords (cdr segment))
	 (len (length coords))	
	 (rlen ([] segclass coordsLength))
	 (seg #f))
    ;;
    (if (eq? len rlen)
	;;
	(begin   
	  (set! seg ([] segclass new))
	  (cond
	   ((eq? rlen 2)
	    ([] seg setCoordsX: (list-ref coords 0) andY: (list-ref coords 1)))
	   ((eq? rlen 6)
	    ([] seg setCoordsX1: (list-ref coords 0) andY1: (list-ref coords 1)
				  X2: (list-ref coords 2) andY2: (list-ref coords 3)
				  X3: (list-ref coords 4) andY3: (list-ref coords 5)))))
	;; Else
	(begin
	  (throw 'wrong-number-of-coords) ;XXX
	  ))
    seg))

;;; spliter ;;;
(define-public (gyve:figs:split-segment currentpoint segment-spec ratio)
  (let ((symbol (car segment-spec))
	(spliter #f)
	(pair #f))
    (cond 
     ((or (eq? symbol 'lineto) (eq? symbol 'moveto))
      (set! spliter gyve:figs:split-lineto))
     ((eq? symbol 'curveto)
      (set! spliter gyve:figs:split-curveto)))
    (set! pair (spliter currentpoint (cdr segment-spec) ratio)) 
    (list (cons symbol (list-ref pair 0))
	  (cons symbol (list-ref pair 1)))))

;; line ;;
(define-public (gyve:figs:split-lineto currentpoint linetopoint ratio)
  (gyve:figs:range-check-zero-one-and-throw ratio)
  (let* ((ax (gyve:figs:x currentpoint))
	 (ay (gyve:figs:y currentpoint))
	 (bx (gyve:figs:x linetopoint))
	 (by (gyve:figs:y linetopoint))
	 (vx (- bx ax))
	 (vy (- by ay)))
    (list (list (+ (* ratio vx) ax) (+ (* ratio vy) ay)) linetopoint)))
  
  
;; curve ;;
(define-public (gyve:figs:curveto-coefficients->points coefficients)
  (let* ((ax (list-ref coefficients 0))
	 (ay (list-ref coefficients 1))
	 (bx (list-ref coefficients 2))
	 (by (list-ref coefficients 3))
	 (cx (list-ref coefficients 4))
	 (cy (list-ref coefficients 5))
	 (x0 (list-ref coefficients 6))
	 (y0 (list-ref coefficients 7))
	 (x1 (+ x0 (/ cx 3)))
	 (y1 (+ y0 (/ cy 3)))
	 (x2 (+ x1 (/ (+ cx bx) 3)))
	 (y2 (+ y1 (/ (+ cy by) 3)))
	 (x3 (+ x0 cx bx ax))
	 (y3 (+ y0 cy by ay)))
    ;; <Japanese>x0, y0$B$,4^$^$l$F$$$J$$$3$H$KCm0U(B</Japanese>
    (list x1 y1 x2 y2 x3 y3))) 
    
(define-public (gyve:figs:curveto-points->coefficients points)
  (let* ((x0 (list-ref points 0))
	 (y0 (list-ref points 1))
	 (x1 (list-ref points 2))
	 (y1 (list-ref points 3))
	 (x2 (list-ref points 4))
	 (y2 (list-ref points 5))
	 (x3 (list-ref points 6))
	 (y3 (list-ref points 7))
	 (ax (- x3 (+ x0 (* 3 (- x2 x1)))))
	 (ay (- y3 (+ y0 (* 3 (- y2 y1)))))
	 (bx (* 3 (- (+ x2 x0) (* 2 x1))))
	 (by (* 3 (- (+ y2 y0) (* 2 y1))))
	 (cx (* 3 (- x1 x0)))
	 (cy (* 3 (- y1 y0))))
    (list ax ay bx by cx cy x0 y0)))

(define-public (gyve:figs:split-curveto currentpoint curvetopoints ratio)
  (gyve:figs:range-check-zero-one-and-throw ratio)
  (let* ((coefficients (gyve:figs:curveto-points->coefficients 
			(append currentpoint curvetopoints))))
    (list (gyve:figs:split-curveto0 coefficients ratio)
	  (gyve:figs:split-curveto1 coefficients ratio))))

(define (gyve:figs:split-curveto0 coefficients ratio)
  (let* ((ax (list-ref coefficients 0))
	 (ay (list-ref coefficients 1))
	 (bx (list-ref coefficients 2))
	 (by (list-ref coefficients 3))
	 (cx (list-ref coefficients 4))
	 (cy (list-ref coefficients 5))
	 (x0 (list-ref coefficients 6))
	 (y0 (list-ref coefficients 7))
	 (AX (* ax ratio ratio ratio ))
	 (AY (* ay ratio ratio ratio ))
	 (BX (* bx ratio ratio))
	 (BY (* by ratio ratio))
	 (CX (* cx ratio))
	 (CY (* cy ratio))
	 (X0 x0)
	 (Y0 y0))
    (gyve:figs:curveto-coefficients->points (list AX AY BX BY CX CY X0 Y0))))
    
(define (gyve:figs:split-curveto1 coefficients ratio)
  (let* ((RATIO (- 1 ratio))
	 (ax (list-ref coefficients 0))
	 (ay (list-ref coefficients 1))
	 (bx (list-ref coefficients 2))
	 (by (list-ref coefficients 3))
	 (cx (list-ref coefficients 4))
	 (cy (list-ref coefficients 5))
	 (x0 (list-ref coefficients 6))
	 (y0 (list-ref coefficients 7))
	 (AX (* ax RATIO RATIO RATIO ))
	 (AY (* ay RATIO RATIO RATIO ))
	 (BX (* RATIO RATIO (+ (* 3 ax ratio) bx)))
	 (BY (* RATIO RATIO (+ (* 3 ay ratio) by)))
	 (CX (* RATIO (+ (* 3 ax ratio ratio) (* 2 bx ratio) cx)))
;;	 (CY (* RATIO (+ (* 3 ax ratio ratio) (* 2 bx ratio) cx)))
	 (CY (* RATIO (+ (* 3 ay ratio ratio) (* 2 by ratio) cy)))
	 (X0 (+ (* ax ratio ratio ratio) (* bx ratio ratio) (* cx ratio) x0))
	 (Y0 (+ (* ay ratio ratio ratio) (* by ratio ratio) (* cy ratio) y0)))
    (gyve:figs:curveto-coefficients->points (list AX AY BX BY CX CY X0 Y0))))
;;;;
; Path
;;

;; * Public Function gyve:figs:create-path ARGS
;;
;; <Japanese>path$B$r@8@.$9$k(B. ARGS$B$O(Bpath$B$N5-=R(B. 
;; path$B$N5-=R$O(Bsegment$B$r5-=R$7$?%j%9%H$G$"$k(B. 
;; segment$B$O(Bmoveto, lineto$B$H(Bcurveto$B$N(B3$B<oN`$,$"$k(B. 
;; segment$B$N5-=R$O(Bsegment$B$N<oN`$N8e$K(B, $BI,MW$J?t$N:BI8$rJB$Y$?%j%9%H(B. 
;; moveto, lineto$B$O(B2$BE@$r<h$k(B. 
;; curveto$B$O(B3$BE@$r<h$k(B. 
;; segment$B$N5-=R$NNc(B:
;; '(moveto 0 0)
;; '(lineto 100 100)
;; '(curveto 50 100 100 100 200 250)
;; $B$=$l$>$l$N0UL#$H$=$N0z?t$OF1L>$N(BPS$B$N%*%Z%l!<%?$HF1$8$G$"$k(B. 
;;
;; path$B$N5-=R$O@hF,$,(Bmoveto$B$G$J$1$l$P$$$1$J$$(B. 
;; path$B$N5-=R$NNc(B($B@5J}7A(B):
;; '((moveto 0 0) (lineto 100 0) (lineto 100 100) (lineto 0 100))
;; </Japanese>
(define-public (gyve:figs:create-path args)
  (let ((target #f)
	(result #f))
    (set! target (car args))
    (set! args (cdr args))
    (if (and (eq? (car target) 'moveto)
	     (eq? (length (cdr target)) 2))
	;; Then
	(set! result (objc-new PSPath
			       initWithStartSegment: (gyve:figs:create-segment target)))
	;; Else
	(throw gyve:figs:moveto-should-be-top))
    (while (not (eq? args '()))
	   (set! target (car args))
	   (set! args (cdr args))
	   ;; [TODO]Use addLinetoSegmentX:andY: and 
	   ;; addCurvetoSegmentX1:andY:X2:andY2:X3:andY3 instead.
	   ([] result addSegment: (gyve:figs:create-segment target)))
    (gyve:figs:set-painting result #t "black")
    result
    ))

;;
;;
;;
(define-public (gyve:figs:is-kind-of-path? target)
  (and (objc-id? target)
       (not (eq? target (objc-get-nil)))
       (objc-bool ([] target isKindOfClass: (objc-class PSPath)))))

;; * Public Function gyve:figs:list->path ARGS
;; 
;; <Japanese>
;; gyve:figs:create-path$B$NJLL>(B
;; </Japanese>
(define-public (gyve:figs:list->path args)
  (gyve:figs:create-path args))

;; <Japanese>gyve:figs:create-path$B$H5U$N$3$H$r$7$^$9(B. 
;; path$B%*%V%8%'%/%H$+$i%j%9%H$r@8@.$7$^$9(B. </Japanese>
(define-public (gyve:figs:path->list path)
  (if (and (objc-id? path) 
	   (objc-bool ([] path conformsToProtocol: 
			  (objc-lookup-protocol "PSPathGeometry"))))
      (let ((result '())
	    (inresult '())
	    (sym #f)
	    (seglen 0)
	    (obj #f)
	    (len ([] path segmentsLength)))
	(while (< 0 len)
	       (set! inresult '())
	       (set! len (- len 1))
	       (set! obj ([] path segmentAtIndex: len))
	       (set! sym (gyve:figs:segment->symbol obj))
	       (set! seglen ([] obj coordsLength))
	       (while (< 0 seglen)
		      (set! seglen (- seglen 1))
		      (set! inresult (cons ([] obj coordAtIndex: seglen)
					   inresult)))
	       (set! inresult (cons sym inresult))
	       (set! result (cons inresult result)))
	result
	)
      #f))

;; * Public Function  gyve:figs:copy-path PATH
;;
;; <Japanese>
;; gyve:figs:create-path$B$G@8@.$7$?(BPATH$B$NJ#@=$rJV$7$^$9(B. 
;; $BJ#@=$5$l$?%Q%9$X$NA`:n$O(BPATH$B$X1F6A$7$^$;$s(B.
;; (XXX$BK\Ev(B? $B$H$$$&$+$^$@(BObjective-C$B$N(B-copy$B5-=R$,40A4$G$J$$(B)
;; </Japanese>
(define-public (gyve:figs:copy-path path)
  ([] path copy))

(define-public (gyve:figs:get-center-of-path path)
  ([] path getCenterOfBBoxAsGOPI: gyve:figs:shared-gopi)
  (list ([] gyve:figs:shared-gopi getX)
	([] gyve:figs:shared-gopi getY)))

(define-public (gyve:figs:get-bbox path)
  (list (list ([] path bboxCoordAtIndex: 0)
	      ([] path bboxCoordAtIndex: 1))
	(list ([] path bboxCoordAtIndex: 2)
	      ([] path bboxCoordAtIndex: 3))))

;;;;
; Path attributes
;;

;; * Public Function  gyve:figs:close-path PATH
;;
;; <Japanese>
;; PATH$B$rJD$8$k(B. 
;; </Japanese>

(define-public (gyve:figs:close-path path)
  ([] path openPath: (objc-bool #f)))

;; * Public Function  gyve:figs:open-path PATH
;;
;; <Japanese>
;; PATH$B$r3+$/(B. 
;; </Japanese>
(define-public (gyve:figs:open-path path)
  ([] path openPath: (objc-bool #t)))

(define-public (gyve:figs:is-closed-path? path)
  (and 
   (not (eq? path (objc-get-nil)))
   (objc-bool ([] path isClosedPath))))

;;;;
; Painting
;;
(define gyve:figs:custom-color-dictionary
  (let ((dict
	(if (or (equal? gyve-main-package "gimp-plugin")
		(equal? gyve-main-package "figs"))
	    (begin ([] (objc-class XCustomColorDictionary) new))
	    (begin ([] ([] (objc-class Gyve) application)
		       customColorDictionary)))
	))
    (lambda () dict)))

(define gyve:figs:pattern-dictionary
  (let ((dict
	 (if (or (equal? gyve-main-package "gimp-plugin")
		 (equal? gyve-main-package "figs"))
	     (begin ([] (objc-class PSPatternDictionary) systemDictionary))
	     (begin ([] ([] (objc-class Gyve) application)
			patternDictionary)))))
    (lambda () dict)))

(define gyve:figs:gradation-dictionary
  (let ((dict
	 (if (or (equal? gyve-main-package "gimp-plugin")
		 (equal? gyve-main-package "figs"))
	     (begin ([] (objc-class PSGradationDictionary) systemDictionary))
	     (begin ([] ([] (objc-class Gyve) application)
			gradationDictionary)))))
    (lambda () dict)))

(define-public (gyve:figs:set-painting obj filling stroking)
  (cond 
   ((or (string? filling) (list? filling) (gyve:figs:is-kind-of-color? filling))
    (gyve:figs:set-color obj filling #f))
   ((gyve:figs:is-kind-of-pattern? filling)
    (gyve:figs:set-pattern obj filling #f))
   ((gyve:figs:is-kind-of-gradation? filling)
    (gyve:figs:set-gradation obj filling))
   ((boolean? filling)
    (if filling 
	(gyve:figs:set-painting-core obj (objc-get-nil) #f)
	(gyve:figs:set-painting-core obj #f #f)))
   ((eq? (objc-get-nil) filling)
    (gyve:figs:set-painting-core obj filling #f))
   (else
    (throw gyve:figs:wrong-painting)))
  (cond 
   ((or (string? stroking) (list? stroking) (gyve:figs:is-kind-of-color? stroking))
    (gyve:figs:set-color obj #f stroking))
   ((gyve:figs:is-kind-of-pattern? stroking)
    (gyve:figs:set-pattern obj #f stroking))
   ((gyve:figs:is-kind-of-gradation? stroking)
    (throw gyve:figs:wrong-painting))
   ((boolean? stroking)
    (if stroking 
	(gyve:figs:set-painting-core obj #f (objc-get-nil))
	(gyve:figs:set-painting-core obj #f #f)))
   ((eq? (objc-get-nil) stroking)
    (gyve:figs:set-painting-core obj #f stroking))
   (else
    (throw gyve:figs:wrong-painting)))
  obj
  )

(define (gyve:figs:set-painting-core obj filling stroking)
  (if (objc-id? filling)
      ([] obj setFillingPaintingApplication:  filling)
      ) ;XXX
  (if (objc-id? stroking)
      ([] obj setStrokingPaintingApplication: stroking)
      ))	;XXX

(define-public (gyve:figs:get-painting obj)
  (list ([] obj fillingPaintingApplication)
	([] obj strokingPaintingApplication)))

;;;
; Pattern
;;
(define-public (gyve:figs:define-pattern name lowerleft upperright color figs)
  (let ((pattern (gyve:figs:create-pattern 
		  lowerleft upperright color figs)))
    (gyve:figs:register-pattern name pattern)
    pattern))

(define (gyve:figs:create-pattern lowerleft upperright color figs)
  (let* ((bbox ([] (objc-new PSSetbboxSegment init)
		   setBBoxLLX: (gyve:figs:x lowerleft)
		          LLY: (gyve:figs:y lowerleft)
		          URX: (gyve:figs:x upperright)
		          URY: (gyve:figs:y upperright)))
	 (co (if (boolean? color)
		    (objc-get-nil)
		    (gyve:figs:create-color color)))
	 (pattern (objc-new PSPattern 
			    initWithBackGroundBBox: bbox
			    andColor: co))
	 (addafig (lambda (a)
		      ([] pattern putFigObjOnTop: a))))
    ;; <Japanese>$B$b$&$9$3$7?'!9$J>l9g$r9MN8$9$k$3$H(B. </Japanese>
    (cond
     ((list? figs)
      (map (lambda (fig)
	     (addafig fig)
	     ) 
	   figs))
     ((objc-id? figs)
      (addafig figs)))
    pattern))

(define (gyve:figs:register-pattern name pattern)
  ([] (gyve:figs:pattern-dictionary) addPattern: pattern named: name))

(define-public (gyve:figs:lookup-pattern name)
  (objc-new PSPatternApplication initWithKey: (objc-nsstring name)
	    andPatternDictionary: (gyve:figs:pattern-dictionary)))

(define-public (gyve:figs:is-kind-of-pattern? target)
  (and (objc-id? target)
       (not (eq? target (objc-get-nil)))
       (objc-bool ([] target isKindOfClass: (objc-lookup-class "PSPatternApplication")))))

(define-public (gyve:figs:set-pattern path filling stroking)
  (cond
   ((gyve:figs:is-kind-of-pattern? stroking)
    (gyve:figs:set-painting-core path #f stroking))
   ((string? stroking)
    (gyve:figs:set-pattern path #f (gyve:figs:lookup-pattern stroking)))
   ((and (boolean? stroking) (not stroking))
    (gyve:figs:set-painting-core path #f #f))
   ((eq? (objc-get-nil) stroking)
    (gyve:figs:set-painting-core obj #f stroking))
   (else
    (throw gyve:figs:wrong-painting)))
  (cond
   ((gyve:figs:is-kind-of-pattern? filling)
    (gyve:figs:set-painting-core path filling #f))
   ((string? filling)
    (gyve:figs:set-pattern path #f (gyve:figs:lookup-pattern filling)))
   ((and (boolean? filling) (not stroking))
    (gyve:figs:set-painting-core path #f #f))
   ((eq? (objc-get-nil) filling)
    (gyve:figs:set-painting-core obj filling #f))
   (else
    (throw gyve:figs:wrong-painting)))
  path)
  
;;;
; Gradation
;;
(define-public (gyve:figs:define-gradation name segments-spec)
  (let ((gradation (gyve:figs:create-gradation segments-spec)))
    (gyve:figs:register-gradation name gradation)
    gradation))

(define (gyve:figs:create-gradation segments-spec)
  (let* ((target (car segments-spec))
	 (spec (cdr segments-spec))
	 (bval #f)
	 (mval #f)
	 (eval #f)
	 (gra #f)
	 (prevseg #f)
	 (new-gradation (lambda (prev)
			  (objc-new PSGradationSegment 
			     initWithPreviousGradationSegment: prev)))
	 (baseseg (new-gradation (objc-get-nil)))
	 (currentseg baseseg))

     (while (not (eq? target '()))
	   ;;
	   (set! bval (gyve:figs:range-check-zero-one-and-throw (list-ref target 1)))
	   (set! mval (gyve:figs:range-check-zero-one-and-throw (list-ref target 2)))
	   (set! eval (gyve:figs:range-check-zero-one-and-throw (list-ref target 3)))
	   ;;
	   ([] currentseg setLeftPosition: bval)
	   ([] currentseg setMiddlePosition: mval)
	   ([] currentseg setRightPosition: eval)
	   ([] currentseg setLeftColor: (gyve:figs:create-color (list-ref target 0)))
	   ([] currentseg setRightColor: (gyve:figs:create-color (list-ref target 4)))
	   ;;
	   (if (eq? 0 (length spec))
	       (set! target '())
	       (begin
		 (set! prevseg currentseg)
		 (set! currentseg (new-gradation prevseg))
		 (set! target (car spec))
		 (set! spec (cdr spec)))))
     (objc-new PSGradation initWithGradationSegments: baseseg)))


(define (gyve:figs:register-gradation name gradation)
  ([] (gyve:figs:gradation-dictionary) addGradation: gradation named: name))

(define-public (gyve:figs:lookup-gradation name)
  (objc-new PSGradationApplication initWithKey: (objc-nsstring name)
	    andGradationDictionary: (gyve:figs:gradation-dictionary)))

(define-public (gyve:figs:is-kind-of-gradation? target)
  (and (objc-id? target)
       (not (eq? target (objc-get-nil)))
       (objc-bool ([] target isKindOfClass: (objc-lookup-class "PSGradationApplication")))))

(define-public (gyve:figs:set-gradation path filling)
  (cond
   ((gyve:figs:is-kind-of-gradation? filling)
    (gyve:figs:set-painting-core path filling #f))
   ((string? filling)
    (gyve:figs:set-gradation path (gyve:figs:lookup-gradation filling)))
   ((boolean? filling) 
    (if filling
	(gyve:figs:set-painting-core path (objc-get-nil) #f)
	(gyve:figs:set-painting-core path #f #f)))
  ((eq? (objc-get-nil) filling)
   (gyve:figs:set-painting-core obj filling #f))
  (else
   (throw gyve:figs:wrong-painting)))
  path)

(define-public (gyve:figs:set-gradation-range gradation from to)
  ([] gradation 
      setBeginningPointByGOPI:
      (objc-new GOPIPoint initWithX: (gyve:figs:x from) andY: (gyve:figs:y from)))
  ([] gradation 
      setEndPointByGOPI:
      (objc-new GOPIPoint initWithX: (gyve:figs:x to) andY: (gyve:figs:y to)))
  ([] gradation calcNormalCross)
  gradation)

(define (gyve:figs:gradation-type-symbol<->enum target)
  (cond 
   ((eq? target 'bar)
    0)
   ((eq? target 'circle)
    -1)
   ((eq? target 0)
    'bar)
   ((eq? target -1)
    'circle)))
(define-public (gyve:figs:set-gradation-type gradation bar-or-circle)
  ([] gradation setFillingType: 
      (gyve:figs:gradations-type-symbol<->enum bar-or-circle))
  gradation)

;;;;
; Color
;;

;; scm string |-> PSCustomColor object
(define-public (gyve:figs:lookup-color name)
  ([] (gyve:figs:custom-color-dictionary) 
      lookUpColorNamed: (string->objc-nsstring name)))

(define-public (gyve:figs:define-custom-color name r g b)
  ([] (gyve:figs:custom-color-dictionary)
      addColorNamed: name red: r green: g blue: b))
           
;; RGB list |-> PSProcessColor object
(define-public (gyve:figs:create-rgb-color r g b)
  (objc-new PSProcessColor 
	    initWithRed: (gyve:figs:range-check-zero-one-and-throw r)
	    green: (gyve:figs:range-check-zero-one-and-throw g)
	    blue: (gyve:figs:range-check-zero-one-and-throw b)))

;; 
(define-public (gyve:figs:is-kind-of-color? target)
  (and (objc-id? target) 
       (not (eq? (objc-get-nil) target))
       (objc-bool ([] target conformsToProtocol: (objc-lookup-protocol "PSColor")))))

;; PSProcessColor or PSCustomColor |-> RGB color list
(define-public (gyve:figs:get-rgb color)
  (if (gyve:figs:is-kind-of-color? color)
      (list ([] color getRed)
	    ([] color getGreen)
	    ([] color getBlue))
      #f))

;; * Public Function gyve:figs:create-color STRING-OR-RGBLIST
;;
;; <Japanese>
;; STRING-OR-RGBLIST$B$H$7$F(B(X11$B$N(B)rgb.txt$B$K$"$k?'$NL>A0$rI=$o$9J8;zNs$"$k$$$O(B, 
;; $BMWAG$r(BRGB$B$H$9$k(B3$B$D$N?t$rMWAG$H$9$k%j%9%H$rM?$($k$3$H$,$-$^$9(B. 
;; $B%j%9%H$NMWAG$H$7$FM-8z$J$N$O(B0$B$+$i(B1$B$^$G$G$9(B. 
;; [0, 1]$B$NHO0O$r1[$($k$H(Bgyve:figs:range-check-zero-one-and-throw$B$,Ht$s$G$-$^$9(B. 
;; </Japanese>
(define-public (gyve:figs:create-color string-or-rgblist)
  (cond 
   ((string? string-or-rgblist)
    (gyve:figs:lookup-color string-or-rgblist))
   ((list? string-or-rgblist)
    (gyve:figs:create-rgb-color (list-ref string-or-rgblist 0)
			  (list-ref string-or-rgblist 1)
			  (list-ref string-or-rgblist 2)))
   ((objc-id? string-or-rgblist
	      string-or-rgblist))
   (else
    #f
   )))

;; * Public Function gyve:figs:set-color PATH FILLING STROKING 
;;
;; <Japanese>
;; PATH$B$N?'$r;XDj$7$^$9(B. 
;; FILLING$B$OEI$jDY$7?'$r(B, STROKING$B$ONX3T$N?'$r;XDj$7$^$9(B. 
;;
;; FILLING/STROKING$B$O(B
;;
;; #f $B$N$H$-?'$rJQ99$7$^$;$s(B. $B$3$l$O(Bfilling$B$"$k$$$O(Bstroking$B$N0lJ}$N$_$rJQ99$7$?$$(B
;; $B>l9g$K;H$$$^$9(B. 
;;
;; #t $B$OF)L@$N;XDj$G$9(B. 
;;
;; $BJ8;zNs$O?'$NL>A0$G$9(B. $B$3$l$O(B(X11$B$N(B)rgb.txt$B$K$"$k?'$NL>A0$,(B
;; $BM-8z$G$9(B. (XXX $B@53N$G$O$J$$(B. )
;; 
;; 3$B$D$N?t$rMWAG$H$9$k%j%9%H$N$H$-(B, $B$=$NMWAG$r(BRGB$B$H$9$k?'$r;XDj$7$^$9(B. $BM-8z$JCM(B
;; $B$O(B0$B$+$i(B1$B$^$G$G$9(B. 
;; </Japanese>
(define-public (gyve:figs:set-color path filling stroking)
  (cond 
   ((gyve:figs:is-kind-of-color? stroking)
    (gyve:figs:set-painting-core path #f stroking))
   ((or (string? stroking) (list? stroking))
    (gyve:figs:set-painting-core path #f (gyve:figs:create-color stroking)))
   ((and (boolean? stroking) (not stroking))
    (gyve:figs:set-painting-core path #f #f))
   ((and (boolean? stroking) stroking)
    (gyve:figs:set-painting-core path #f (objc-get-nil)))
   ((eq? (objc-get-nil) stroking)
    (gyve:figs:set-painting-core obj #f stroking))
   (else
    (throw gyve:figs:wrong-painting)))
  (cond 
   ((gyve:figs:is-kind-of-color? filling)
    (gyve:figs:set-painting-core path filling #f))
   ((or (string? filling) (list? filling))
    (gyve:figs:set-painting-core path (gyve:figs:create-color filling) #f))
   ((and (boolean? filling) (not filling))
    (gyve:figs:set-painting-core path #f #f))
   ((and (boolean? filling) filling)
    (gyve:figs:set-painting-core path (objc-get-nil) #f))
   ((eq? (objc-get-nil) filling)
    (gyve:figs:set-painting-core obj filling #f))
   (else
    (throw gyve:figs:wrong-painting)))
  path)

;;;;
; Other painting attributes(PaintStyle)
;;
(define-public (gyve:figs:set-line-width path width)
  ([] path setLineWidth: width))

(define-public (gyve:get-line-width path)
  ([] path lineWidth))

(define-public (gyve:figs:set-miter-limit path limit)
  ([] path setMiterLimit: limit))

(define-public (gyve:figs:get-miter-limit path)
  ([] path getMiterLimit))

(define-public (gyve:figs:set-dash-pattern path pattern phase)
  (let ((dash #f)
	(len (length pattern))
	(i 0))
    ;; 
    (set! dash (objc-new PSDynamicDashPattern initWithDashArrayLength: len))
    (while (< i len)
	   ([] dash setDashArray: (list-ref pattern i) atIndex: i)
	   (set! i (1+ i)))
    ([] dash setDashPhase: phase)
    ([] path setDashPattern: dash)
    path))

;; Retun: ((pattern). phase) e.g. : ((1 0 1) . 1)
(define-public (gyve:figs:get-dash-pattern path)
  (let* ((dash ([] path dashPattern))
	 (len (1- ([] dash arrayLength)))
	 (phase ([] dash dashPhase))
	 (result '()))
    (while (<= 0 len)
	   (set! result (cons ([] dash arrayAtIndex: len) result))
	   (set! len (1- len)))
    (cons result phase)))

;;
;; joinsym := mitered|round|beveled
;;
(define (gyve:figs:line-join-symbol<->enum target)
  (if (symbol? target)
      (cond
       ((eq? target 
	     'mitered) 0)
       ((eq? target
	     'round) 1)
       ((eq? target
	     'beveled) 2))
      (cond
       ((eq? target 
	     0) 'mitered)
       ((eq? target
	     1) 'round)
       ((eq? target
	     2) 'beveled))))

(define-public (gyve:figs:set-line-join path joinsym)
  ([] path setLineJoin: (gyve:figs:line-join-symbol<->enum joinsym)))

(define-public (gyve:figs:get-line-join path)
 (gyve:figs:line-join-symbol<->enum ([] path lineJoin)))
  
;;
;; capsym := butt|round|square
;;
(define (gyve:figs:line-cap-symbol<-> target)
  (if (symbol? target)
      (cond
       ((eq? target 
	     'butt) 0)
       ((eq? target
	     'round) 1)
       ((eq? target
	     'square) 2))
      (cond
       ((eq? target 
	     0) 'butt)
       ((eq? target
	     1) 'round)
       ((eq? target
	     2) 'square))))

(define-public (gyve:figs:set-line-cap path capsym)
  ([] path setLineCap: (gyve:figs:line-cap-symbol<-> capsym)))

(define-public (gyve:figs:get-line-cap path)
  (gyve:figs:line-cap-symbol<-> ([] path getLineCap)))



;;;;
; Matrix
;;
(define-public (gyve:figs:apply-matrix path matrix)
  ([] matrix applyMatrixTo: path)
  path);XXX

;; trans  
(define-public (gyve:figs:create-trans-matrix dx dy)
  (objc-new PSTransMatrixApplication
	    initWithTransMatrix: (objc-new PSTransMatrix 
					   initWithTransPointX: dx andY: dy)))

(define-public (gyve:figs:trans path dx dy)
  (gyve:figs:apply-matrix path (gyve:figs:create-trans-matrix dx dy)))

;; rotate
(define-public (gyve:figs:create-rotate-matrix radian center)
  (objc-new PSRotateMatrixApplication 
	    initWithRotateMatrix: (objc-new PSRotateMatrix 
					    initWithRotateAngle: radian)
	    andCenterX: (gyve:figs:x center) andY: (gyve:figs:y center)))

(define-public (gyve:figs:rotate path radian center)
  (if (boolean? center)
      (gyve:figs:apply-matrix path 
			      (gyve:figs:create-rotate-matrix 
			       radian (gyve:figs:get-center-of-path path)))
      (gyve:figs:apply-matrix path 
			      (gyve:figs:create-rotate-matrix 
			       radian 
			       center))))

;; scale
(define-public (gyve:figs:create-scale-matrix expandx expandy center)
  (objc-new PSScaleMatrixApplication
	    initWithScaleMatrix: (objc-new PSScaleMatrix
					   initWithScaleX: expandx
					   andY: expandy)
	    andOriginX: (gyve:figs:x center) andY: (gyve:figs:y center)))
  
(define-public (gyve:figs:scale path expandx expandy center)
  (if (boolean? center)
      (gyve:figs:apply-matrix path 
			      (gyve:figs:create-scale-matrix 
			       expandx expandy 
			       (gyve:figs:get-center-of-path path)))
      (gyve:figs:apply-matrix path 
			      (gyve:figs:create-scale-matrix 
			       expandx expandy
			       center))))
;; slant
(define-public (gyve:figs:create-slant-matrix slantangle axistangle center)
  (objc-new PSSlantMatrixApplication
	    initWithSlantMatrix:
	    (objc-new PSSlantMatrix initWithSlantAngle: slantangle 
                                          andAxisAngle: axistangle
					  )
	    					  
	    andOriginX: (gyve:figs:x center)
	    andY: (gyve:figs:y center)
	    ))

(define-public (gyve:figs:slant path slantangle axistangle center)
  (gyve:figs:apply-matrix path
			  (gyve:figs:create-slant-matrix
			   slantangle axistangle center)))

;; reflect
(define-public (gyve:figs:create-reflect-matrix mirrorangle center)
  (if (boolean? center)
      (set! center (gyve:figs:get-center-of-path path)))
  (objc-new PSReflectMatrixApplication
	    initWithReflectMatrix: (objc-new PSReflectMatrix
					     initWithReflectAxisX: 1.0
					     andY: (tan mirrorangle))
	    andOriginX: (gyve:figs:x center)
	    andY: (gyve:figs:y center)))

(define-public (gyve:figs:reflect path mirrorangle center)
  (gyve:figs:apply-matrix path
			  (gyve:figs:create-reflect-matrix mirrorangle center)))
;;;;
; Group
;;
(define-public (gyve:figs:create-group figslist)
  (let ((group (objc-new GyveFigGroup init)))
    (map (lambda (x)
	   ([] group putFigObjOnTop: x))
	 figslist)
    group))

(define-public (gyve:figs:is-kind-of-group? target)
  (and (objc-id? target)
       (not (eq? (objc-get-nil) target))
       (objc-bool ([] target isKindOfClass: (objc-class GyveFigGroup)))))

;;;;
; Mask
;;
(define-public (gyve:figs:create-mask mask maskedobject)
  (cond 
   ((gyve:figs:is-kind-of-path? maskedobject)
    (objc-new GyveMask initWithMaskPath: mask andMaskedObject: maskedobject))
   ((and (list? maskedobject) (objc-id? (car maskedobject)))
    (let ((result (objc-new GyveMask initWithMaskPath: mask)))
      (map (lambda (x)
	     ([] result putFigObjOnTop: x))
	 maskedobject)
      result))
   (else
     #f
     )))

(define-public (gyve:figs:is-kind-of-mask? target)
  (and (objc-id? target)
       (not (eq? target (objc-get-nil)))
       (objc-bool ([] target isKindOfClass: (objc-class GyveMask)))))
    
;;;;
; Compound Path
;;
(define-public (gyve:figs:create-compound-paths basepath paths)
  (let ((compound (objc-new GyveCompoundPaths initWithFigObj: basepath)))
    (cond
     ((gyve:figs:is-kind-of-path? paths)
      ([] compound putFigObjOnTop: paths)
      compound)
     ((and (list? paths) (objc-id? (car paths)))
      (map (lambda (x)
	     ([] compound putFigObjOnTop: x))
	   paths)
      compound)
     (else
      #f))))

(define-public (gyve:figs:is-kind-of-compound-paths? target)
  (and (objc-id? target)
       (not (eq? (objc-get-nil) target))
       (objc-bool ([] target isKindOfClass: (objc-class GyveCompoundPaths)))))
