;;; gimp-plugin.scm --- 
   
;;;;   Copyright (C) 1997 GYVE Development Team
;;;;
;;;;   Author: Masatake YAMATO (masata-y@is.aist-nara.ac.jp)
;;;;   Created: Wed Oct 29 01:13:55 1997
;;;;   Time-stamp: <98/03/29 14:18:54 masata-y>
;;;;   
;;;;   This file is part of the GYVE vector based drawing editor. 
;;;;
;;;;   This program conforms GNU GENERAL PUBLIC LICENSE Version 2.

(define-module (gyve gimp-plugin) 
  :use-module (languages guileobjc) 
  :use-module (gyve figs))

;;;;
;; Printer
;;
(define printer
  (let* ((p (objc-new PSPathPrinter init)))
    (lambda () p)))

(define-public (gyve:gimp-plugin:print-header)
  ([] (printer) writeHeader))

(define-public (gyve:gimp-plugin:print-footer)
  ([] (printer) writeFooter))

(define printer:header-printed #f)

;; * Public Function gyve:figs:print PATH-OR-LIST
;;
;; <Japanese>
;; path-or-list$B$O(Bgyve:figs:create-path$BEy$G@8@.$5$l$?(Bpath$B$"$k$$$O(B, $B$=$N%j%9%H$r<h$j$^$9(B. 
;; $B%j%9%H$N>l9g@hF,$+$i=g$K=PNO$5$l$^$9(B. 
;; </Japanese>
(define-public (gyve:gimp-plugin:print path-or-list-or-group)
  (if (not printer:header-printed)
      (begin
	(gyve:gimp-plugin:print-header)
	(set! printer:header-printed #t)))
  (cond
   ((gyve:figs:is-kind-of-path? path-or-list-or-group)
    ([] path-or-list-or-group
	foreachSegmentWithObject: (printer)))
   ((gyve:figs:is-kind-of-compound-paths? path-or-list-or-group)
    ([] path-or-list-or-group
	foreachSegmentWithObject: (printer)))
   ((gyve:figs:is-kind-of-group? path-or-list-or-group)
    ([] path-or-list-or-group foreachFigObjFromBottomWithObject: (printer)))
   ((list? path-or-list-or-group)
    (map (lambda (p) (gyve:gimp-plugin:print p))
	 path-or-list-or-group))
   (else
    (throw gyve:figs:un-printable-object))))

(define-public (gyve:gimp-plugin:set-max-page p)
  ([] (printer) setMaxPage: p))

(define-public (gyve:gimp-plugin:newpage)
  ([] (printer) newPage))